﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using System.Management.Automation.Runspaces;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Cluster.Disable
{
    // <summary>
    /// The DisableEncryptionAtRest method is used to remove the encryption that was previously applied to the cluster using the EnableEncryptionAtRest method.
    /// Enabling or disabling encryption should be performed when the cluster is running and in a healthy state. 
    /// Encryption can be enabled or disabled at your discretion and can be performed as often as you need.
    /// Note: This process is asynchronous and returns a response before encryption is disabled. 
    /// The GetClusterInfo method can be used to poll the system to see when the process has completed.
    /// </summary>
    
    [Cmdlet(VerbsLifecycle.Disable, "SFEncryptionAtRest", SupportsShouldProcess = true, ConfirmImpact = ConfirmImpact.High)]
    public class DisableSFEncryptionAtRest : SFCmdlet
    {
        #region Private Data

        #endregion

        #region Parameters

        #endregion

        #region Cmdlet Overrides
        
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection();
        }

        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            
            SendRequest<DisableEncryptionAtRestResult>("DisableEncryptionAtRest");
        }

        #endregion
    }
}