﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;

#endregion

namespace SolidFire.Cluster.Get
{
    /// <summary>
    /// Used to list all of the clusters a cluster is paired with.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFClusterPair")]
    public class GetSFClusterPair : SFCmdlet
    {
        #region Private Data

        #endregion

        #region Parameters

        #endregion

        #region Cmdlet Overrides
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection();
        }

        protected override void ProcessRecord()
        {
            base.ProcessRecord();
          var  objsFromAPI = SendRequest<ListClusterPairsResult>("ListClusterPairs");

          foreach (var obj in objsFromAPI)
          {
              WriteObject(obj.Result.ClusterPairs, true);
          }
        }

        #endregion
    }
}
