﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core.Helpers;
using SolidFire.Core;
using SolidFire.Element.Api;
using System.Linq;
#endregion

namespace SolidFire.Cluster.Get
{
    /// <summary>
    /// Used to return high-level activity measurements for the cluster.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFClusterState")]
    public class GetSFClusterState : SFCmdlet
    {
        #region Private Data

        #endregion

        #region Parameters

        #endregion

        #region Cmdlet Overrides
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection();
        }
        /// <summary>
        /// 
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var request = new GetClusterStateRequest()
            {
                Force = true
            };

            var objsFromAPI = SendRequest<GetClusterStateResult>("GetClusterState", request);

            objsFromAPI.ForEach(o => WriteObject(o.Result.Nodes, true));
        }


        #endregion
    }
}
