﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Cluster.Get
{
    /// <summary>
    /// ListClusterAdmins returns the list of all cluster administrators for the cluster. There can be several cluster administrators that have
    /// different levels of permissions. There can be only one primary cluster administrator in the system. The primary Cluster Admin is the
    /// administrator that was created when the cluster was created.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFCurrentClusterAdmin")]
    public class GetSFCurrentClusterAdmin : SFCmdlet
    {
        #region Cmdlet Overrides
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection();
        }
        /// <summary>
        /// 
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<GetCurrentClusterAdminResult>("GetCurrentClusterAdmin");

            foreach (var obj in objsFromAPI)
            {
                WriteObject(obj.Result.ClusterAdmin, true);
            }

        }
        #endregion
    }
}
