﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Cluster.Get
{

    /// <summary>
    /// ISCSI Session object returns information about each volume iSCSI session connection. iSCSI information is returned with the API method, ListISCSISessions.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFIscsiSession", DefaultParameterSetName = "Cluster")]
    public class GetSFIscsiSession : SFCmdlet
    {
        #region Private Data

        #endregion

        #region Parameters

        #endregion

        #region Cmdlet Overrides
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection();
        }
        /// <summary>
        /// 
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<ListISCSISessionsResult>("ListISCSISessions");

            foreach (var obj in objsFromAPI)
            {
                WriteObject(obj.Result.Sessions, true);
            }
        }

        #endregion
    }
}

