﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using System.Linq;
using SolidFire.Element.Api;

#endregion

namespace SolidFire.Cluster.Get
{
    /// The Get-SFNetworkInterface CmdLet is used to return information about each network interface on all nodes in a cluster. 
    
    [Cmdlet(VerbsCommon.Get, "SFNetworkInterface")]
    public class GetSFNetworkInterface : SFCmdlet
    {
        #region Private Data

        #endregion

        #region Parameters

        #endregion

        #region Cmdlet Overrides


        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection(minVersionNumber: 7.0f, endPoint: Core.Helpers.SolidFireUtilities.SFEndPoint.Node);
        }
        /// <summary>
        /// 
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            
            var objsFromAPI = SendRequest<ListNetworkInterfacesResult>("ListNetworkInterfaces");
            
            WriteObject(objsFromAPI.Select(obj => obj.Result), true);
            
        }

        #endregion
    }
}
