﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using System.Collections;

#endregion

namespace SolidFire.Cluster.Get
{
    /// <summary>
    /// The Get-SFRawStats cmdlet is used by SolidFire engineering to troubleshoot new features. 
    /// The data returned from Get-SFRawStats is not documented, it changes frequently, and is 
    /// not guaranteed to be accurate. It is not recommended to ever use Get-SFRawStats for 
    /// collecting performance data or any other management integration with a SolidFire cluster.
    /// The data returned from Get-SFRawStats changes frequently, and is not guaranteed to accurately 
    /// show performance from the system. It is not recommended to ever use Get-SFRawStats for collecting 
    /// performance data or any other management integration with a SolidFire cluster.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFRawStats")]
    public class GetSFRawStats : SFCmdlet
    {
        #region Private Data

        #endregion

        #region Parameters

        #endregion

        #region Cmdlet Overrides
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection();
        }

        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<Hashtable>("GetRawStats");

            foreach (var obj in objsFromAPI)
            {
                WriteObject(obj.Result, true);
            }
        }

        #endregion
    }
}