﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
using System.Linq;

#endregion

namespace SolidFire.Cluster.Get
{
    /// <summary>
    /// Get-SFRemoteLoggingHost is used to retrieve the current list of log servers.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFRemoteLoggingHost")]
    public class GetSFRemoteLoggingHost : SFCmdlet
    {
        #region Cmdlet Overrides
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection();
        }

        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<GetRemoteLoggingHostsResult>("GetRemoteLoggingHosts");

            WriteObject(objsFromAPI.Select(obj => obj.Result.RemoteHosts), true);
        }

        #endregion
    }
}
