﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Cluster.Get
{
    /// <summary>
    /// GetSnmpTrapInfo is used to return current SNMP trap configuration information.
    /// </summary>

    [Cmdlet(VerbsCommon.Get, "SFSnmpTrapInfo", DefaultParameterSetName = "Cluster")]
    public class GetSFSnmpTrapInfo : SFCmdlet
    {
        #region Private Data

        #endregion

        #region Parameters

        #endregion

        #region Cmdlet Overrides

        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection();
        }

        /// <summary>
        /// 
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<GetSnmpTrapInfoResult>("GetSnmpTrapInfo");
            foreach (var obj in objsFromAPI)
            {
                WriteObject(obj.Result, true);
            }
        }

        #endregion
    }
}