﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.Collections;
using System.Linq;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Core.Helpers;
using SolidFire.Element.Api;

#endregion

namespace SolidFire.Cluster.Reset
{

    [Cmdlet(VerbsLifecycle.Restart, "SFNetworking", SupportsShouldProcess = true,
        ConfirmImpact = ConfirmImpact.High)]
    public class RestartSFNetworking : SFCmdlet
    {
        #region Cmdlet Overrides

        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection(endPoint: SolidFireUtilities.SFEndPoint.Node);
        }

        /// <summary>
        /// 
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var request = new RestartNetworkingRequest {Force = true};
            WriteWarning(
                "This restarts all networking services on a node, causing temporary loss of networking connectivity.");

            WriteObject(SendRequest<Hashtable>("RestartNetworking", request).Select(r => r.Result), true);
        }

        #endregion
    }
}