﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

namespace SolidFire.Core.Enums
{
    /// <summary>
    /// 
    /// </summary>
    public static class SolidFireEnums
    {
        /// <summary>
        /// 
        /// </summary>
        public enum AccountStatus
        { 
            /// <summary>
            /// 
            /// </summary>
            Active = 0,
            /// <summary>
            /// 
            /// </summary>
            Locked = 1,
            /// <summary>
            /// 
            /// </summary>
            Removed = 2
        }


        /// <summary>
        /// 
        /// </summary>
        public enum ClusterFaultCodes
        {
            /// <summary>
            /// A Block Service is using too much space. To rectify this, add more provisioned capacity. 
            /// </summary>
            BlockServiceTooFull = 0,
            /// <summary>
            /// A Block Service has been detected as unhealthy. SolidFire is automatically decommissioning data and re-replicating its data onto other healthy drives.
            /// </summary>
            BlockServiceUnhealthy = 1,
            /// <summary>
            /// There is not enough free space to support a single node loss. To rectify this, add another SolidFire node to the cluster.
            /// </summary>
            ClusterFull = 2,
            /// <summary>
            /// There is an out of space condition and data on the offline block storage drives cannot be synced to drives that are still active. To rectify, add more storage.
            /// </summary>
            ClusterCannotSync = 3,
            /// <summary>
            /// Cluster IOPS are over provisioned. The sum of all minimum QoS IOPS is greater than the expected IOPS (50000) of the cluster. Minimum QoS cannot be maintained for all volumes simultaneously.
            /// </summary>
            ClusterIOPSAreOverProvisioned = 4,
            /// <summary>
            /// Fault seen if any cluster pairing is either disconnected or misconfigured.
            /// </summary>
            DisconnectedClusterPair = 5,
            /// <summary>
            /// A drive's remaining life has dropped below thresholds. It is still functioning but should be replaced soon.
            /// </summary>
            DriveWearFault = 6,
            /// <summary>
            /// Network connectivity or power has been lost to one or more of the ensemble nodes. Restore network connectivity or power.
            /// </summary>
            EnsembleDegraded = 7,
            /// <summary>
            /// A fault reported that is other than a routine fault. These faults are not automatically cleared from the fault queue. Call SolidFire Support to resolve these exceptions. 
            /// </summary>
            Exception = 8,
            /// <summary>
            /// A Block Service is not responding to data write requests. This causes the Slice Service to run out of space to store failed writes. Bring Block Services back up to allow writes to continue normally and failed space to be flushed from the Slice Service.
            /// </summary>
            FailedSpaceTooFull = 9,
            /// <summary>
            /// The following node hardware fault messages can be generated: Fan, Temperature Sensor, Network Interface, Power Supply.
            /// </summary>
            NodeHardwareFault = 10,
            /// <summary>
            /// The overall provisioned capacity of the cluster is too full. To rectify this, add more provisioned space, or delete and purge volumes.
            /// </summary>
            ProvisionedSpaceTooFull = 11,
            /// <summary>
            /// SolidFire has detected that a Slice Service is unhealthy and is automatically decommissioning it.
            /// </summary>
            SliceServiceUnhealthy = 12,
            /// <summary>
            /// A Slice Service has too little provisioned capacity assigned to it. To rectify this, add more provisioned capacity.
            /// </summary>
            SliceServiceTooFull = 13,
            /// <summary>
            /// Secondary volumes have not yet completely replicated and synced. This message will be cleared when the syncing is complete.
            /// </summary>
            VolumesDegraded = 14
        }

        /// <summary>
        /// 
        /// </summary>
        public enum EncryptionAtRestState
        {
            /// <summary>
            /// 
            /// </summary>
            Disabled = 0,
            /// <summary>
            /// 
            /// </summary>
            Disabling = 1,
            /// <summary>
            /// 
            /// </summary>
            Enabled = 2,
            /// <summary>
            /// 
            /// </summary>
            Enabling = 3
        }

        /// <summary>
        /// 
        /// </summary>
        public enum State
        {
            /// <summary>
            /// 
            /// </summary>
            Available = 0,
            /// <summary>
            /// 
            /// </summary>
            Pending = 1,
            /// <summary>
            /// 
            /// </summary>
            Active = 2
        }

        /// <summary>
        /// 
        /// </summary>
        public enum Access
        {
            /// <summary>
            /// 
            /// </summary>
            ReadOnly = 0,
            /// <summary>
            /// 
            /// </summary>
            ReadWrite = 1,
            /// <summary>
            /// 
            /// </summary>
            Locked = 2
        }

        /// <summary>
        /// 
        /// </summary>
        public enum VolumeStatus
        {
            /// <summary>
            /// 
            /// </summary>
            Init = 0,
            /// <summary>
            /// 
            /// </summary>
            Active = 1,
            /// <summary>
            /// 
            /// </summary>
            Deleted = 2
        }

        public enum VersionName
        {
            Hydrogen,
            Helium,
            Lithium,
            Beryllium,
            Boron,
            BoronPatch1,
            Carbon,
            Nitrogen,
            NitrogenPatch1,
            NitrogenPatch2,
            NitrogenPatch3,
            NitrogenPatch4,
            Oxygen,
            OxygenPatch1,
            OxygenPatch2,
            OxygenPatch3,
            OxygenPatch4,
            OxygenPatch5,
            OxygenPatch6,
            OxygenPatch7,
            OxygenPatch8,
            OxygenPatch9,
            OxygenPatch10,
            Fluorine,
            FluorinePatch1,
            FluorinePatch2,
            FluorinePatch3,
            FluorinePatch4,
            FluorinePatch5,
            FluorinePatch6,
            FluorinePatch7,
            FluorinePatch8,
            FluorinePatch9
        }
    }

}