﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

namespace SolidFire.Core.Extensions
{
    /// <summary>
    /// Functions for extensions to exising class used for conversion or validation
    /// of values for parameters to CmdLets.
    /// </summary>
    public static class SolidFireExtensions
    {
        /// <summary>
        /// Method used to determine if a string is exactly empty. A null string is 
        /// not considered empty with this test.
        /// </summary>
        /// <param name="value">The string to test if empty.</param>
        /// <returns>True if the string is null, if not null the result String.IsNullOrEmpty is returned.</returns>
        public static bool IsExactlyEmpty(this string value)
        {
            // A null value is not considered empty. If the value does not 
            // test equal to null, the string test for null or empty can be used.
            return (value == null) ? false : string.IsNullOrEmpty(value);
        }

    }
}