﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System;
using System.Runtime.Serialization;

#endregion

namespace SolidFire.Core.Objects
{
    /// <summary>
    /// 
    /// </summary>
    /// <typeparam name="T"></typeparam>
    /// <returns></returns>
    [DataContract]
    public class SFWrapper<T>
    {
        #region Public Properties

        /// <summary>
        /// 
        /// </summary>
        [Obsolete]
        public String InputJson
        {
            get;
            set;
        }

        /// <summary>
        /// 
        /// </summary>
        [Obsolete]
        public String ReturnJson
        {
            get;
            set;
        }

        public SFConnection Target
        {
            get;
            set;
        }

        /// <summary>
        /// 
        /// </summary>
        [DataMember(Name = "id", IsRequired = false )]
        public String ID
        {
            get;
            set;
        }

        /// <summary>
        /// 
        /// </summary>
        [DataMember(Name = "error", IsRequired = false )]
        public SFError Error
        {
            get;
            set;
        }

        /// <summary>
        /// 
        /// </summary>
        [DataMember(Name = "result", IsRequired = false)]
        public T Result
        {
            get;
            set;
        }

        #endregion
    }


    /// <summary>
    /// 
    /// </summary>
    [DataContract(Name = "error")]
    public class SFError
    {
        #region Public Properties

        /// <summary>
        /// 
        /// </summary>
        [DataMember(Name = "code", IsRequired = false)]
        public Int64 Code
        {
            get;
            set;
        }

        /// <summary>
        /// 
        /// </summary>
        [DataMember(Name = "name", IsRequired = false)]
        public String Name
        {
            get;
            set;
        }

        /// <summary>
        /// 
        /// </summary>
        [DataMember(Name = "message", IsRequired = false)]
        public String Message
        {
            get;
            set;
        }

        #endregion
    }
}