﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using SolidFire.Core.Enums;
using SolidFire.Exceptions;
using SolidFire.Core.Helpers;
#endregion

namespace SolidFire.Core.Objects
{
    public class SolidFireVersionApi
    {
        public static string[] Releases { get { return _releases; } }

        private static readonly string[] _releases = new string[]
        {
            "Hydrogen",
            "Helium",
            "Lithium",
            "Beryllium",
            "Boron",
            "Carbon",
            "Nitrogen",
            "Oxygen",
            "Fluorine",
            "Neon",
            "Sodium",
            "Magnesium",
            "Aluminum",
            "Silicon",
            "Phosphorus",
            "Sulfur",
            "Chlorine",
            "Potassium",
            "Argon",
            "Calcium",
            "Scandium",
            "Titanium",
            "Vanadium",
            "Chromium",
            "Manganese",
            "Iron",
            "Cobalt",
            "Nickel",
            "Copper",
            "Zinc",
            "Gallium",
            "Germanium",
            "Arsenic",
            "Selenium",
            "Bromine",
            "Krypton",
            "Rubidium",
            "Strontium",
            "Yttrium",
            "Zirconium",
            "Niobium",
            "Molybdenum",
            "Technetium",
            "Ruthenium",
            "Rhodium",
            "Palladium",
            "Silver",
            "Cadmium",
            "Indium",
            "Tin",
            "Antimony",
            "Tellurium",
            "Iodine",
            "Xenon",
            "Caesium",
            "Barium",
            "Lanthanum",
            "Cerium",
            "Praseodymium",
            "Neodymium",
            "Promethium",
            "Samarium",
            "Europium",
            "Gadolinium",
            "Terbium",
            "Dysprosium",
            "Holmium",
            "Erbium",
            "Thulium",
            "Ytterbium",
            "Lutetium",
            "Hafnium",
            "Tantalum",
            "Tungsten",
            "Rhenium",
            "Osmium",
            "Iridium",
            "Platnum",
            "Gold",
            "Mercury"
        };

        public static VersionApi GetByNumber(float number)
        {
            if (_releases.Length < (int)number)
            {
                return new VersionApi(number, "Unknown");
            }
            return new VersionApi(number, _releases[(int)number - 1]);
        }
        public const float MinVersionApiNumber = 7.0f;
        public const float MaxVersionApiNumber = 80.0f; // The Atomic Number of Mercury!
    }

    public class VersionApi
    {
        public VersionApi(float number, string name)
        {
            Number = number;
            Name = name;
        }
        public float Number;
        public string Name;
    }
}
