﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives
using SolidFire.Exceptions;
using System;
using System.Management.Automation;
using System.Text.RegularExpressions;
#endregion

namespace SolidFire.Core.Validation
{
    [AttributeUsage(AttributeTargets.Property | AttributeTargets.Field)]
    public class SFValidatePatternAttribute : ValidateEnumeratedArgumentsAttribute
    {
        public SFValidatePatternAttribute(string regexPattern, string mismatchMessage)
        {
            RegexPattern = regexPattern;
            MismatchMessage = mismatchMessage;
        }

        public string RegexPattern { get; set; }

        public string MismatchMessage { get; set; }

        protected override void ValidateElement(object element)
        {
           if (!Regex.IsMatch(element.ToString(), RegexPattern))
            {
                throw new ParameterException(MismatchMessage);
            }
        }
    }
}
