﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core.Helpers;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Drive.Get
{
    
    [Cmdlet(VerbsCommon.Get, "SFDriveConfig", SupportsShouldProcess = true, ConfirmImpact = ConfirmImpact.Medium)]
    public class GetSFDriveConfig : SFCmdlet
    {
        #region Parameters
        // no parameters
        #endregion

        #region Cmdlet Overrides
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection(endPoint: SolidFireUtilities.SFEndPoint.Node);
        }

        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<GetDriveConfigResult>("GetDriveConfig");

            foreach (var obj in objsFromAPI)
            {
                WriteObject(obj.Result.DriveConfig, true);
            }
        }
        #endregion
    }
}
