#region Copyright
/*
* Copyright 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion


#region Using Directives
using System;
using System.Linq;
using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core.Validation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Hardware
{
	/// <summary>
	/// GetNvramInfo allows you to retrieve information from each node about the NVRAM card.  
	/// </summary>
	
	[Cmdlet(VerbsCommon.Get, "SFNvramInfo")]
	public class GetNvramInfo : SFCmdlet
	{
		#region Private Data
		#endregion
		
		#region Parameters
		#endregion
		
		#region Cmdlet Overrides
		protected override void BeginProcessing()
		{
			base.BeginProcessing();
			CheckConnection(endPoint: Core.Helpers.SolidFireUtilities.SFEndPoint.Node);
		}

		protected override void ProcessRecord()
		{
			base.ProcessRecord();
			var objsFromAPI = SendRequest<GetNvramInfoResult>("GetNvramInfo", new GetNvramInfoRequest());
			WriteObject(objsFromAPI.Select(obj => obj.Result.NvramInfo), true);
		}
		#endregion
	}
}
		