﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core.Helpers;
using SolidFire.Core;
using SolidFire.Element.Api;

#endregion

namespace SolidFire.Node.Get
{
    /// <summary>
    /// The GetSFClusterConfig API method is used to return information about the cluster configuration 
    /// this node uses to communicate with the cluster it is a part of.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFClusterConfig")]
    public class GetSFClusterConfig : SFCmdlet
    {
        #region Cmdlet Overrides

        /// <summary>
        /// Implementation for checking the status of the connection and
        /// validate that the connection is a node.
        /// </summary>
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection(endPoint: SolidFireUtilities.SFEndPoint.Node);
        }

        /// <summary>
        /// Implements processing for the GetClusterConfig API method.
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<GetClusterConfigResult>("GetClusterConfig");

            foreach (var obj in objsFromAPI)
            {
                WriteObject(obj.Result.Cluster, true);
            }
        }

        #endregion
    }
}
