﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core.Helpers;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Node.Get
{
    /// <summary>
    /// The GetConfig API method is used to retrieve all the configuration information for the node. 
    /// This one API method includes the same information available in both GetClusterConfig and GetNetworkConfig API methods.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFConfig")]
    public class GetSFConfig : SFCmdlet
    {
        #region Cmdlet Overrides

        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection(endPoint: SolidFireUtilities.SFEndPoint.Node);
        }

        /// <summary>
        /// Implements processing for the GetConfig API method.
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<GetConfigResult>("GetConfig");
            foreach (var obj in objsFromAPI)
            {
                WriteObject(obj.Result.Config, true);
            }
        }

        #endregion
    }
}
