﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core.Helpers;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Node.Get
{
    /// <summary>
    /// The GetNetworkConfig API method is used to display the network configuration information for a node.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFNetworkConfig")]
    public class GetSFNetworkConfig : SFCmdlet
    {
        #region Cmdlet Overrides

        /// <summary>
        /// Implementation for checking the status of the connection and
        /// validate that the connection is a node.
        /// </summary>
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection(endPoint: SolidFireUtilities.SFEndPoint.Node);
        }

        /// <summary>
        /// Implements processing for the GetNetworkConfig API method.
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<GetNetworkConfigResult>("GetNetworkConfig");

            foreach (var obj in objsFromAPI)
            {
                WriteObject(obj.Result.Network, true);
            }
        }

        #endregion
    }
}
