﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
using System.Linq;

#endregion

namespace SolidFire.Node.Get
{
    /// <summary>
    /// Used to detect an operation on a node that is currently in progress. This method can also be used to report back when an operation has completed.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFPendingOperation")]
    public class GetSFPendingOperation : SFCmdlet
    {
        #region Cmdlet Overrides
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection(endPoint: Core.Helpers.SolidFireUtilities.SFEndPoint.Node);
        }

        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<GetPendingOperationResult>("GetPendingOperation");
            
            WriteObject(objsFromAPI.Select(obj => obj.Result), true);
            
        }

        #endregion
    }
}