﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
using SolidFire.Core.Helpers;
using System.Linq;

#endregion

namespace SolidFire.Node.Get
{
    /// <summary>
    /// Used to return the utilities that are available to run on a node.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Get, "SFUtilities")]
    public class GetSFUtilities : SFCmdlet
    {

        #region Cmdlet Overrides

        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection(endPoint: SolidFireUtilities.SFEndPoint.Node);
        }

        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            var objsFromAPI = SendRequest<ListUtilitiesResult>("ListUtilities");
            WriteObject(objsFromAPI.Select(obj => obj.Result), true);
        }

        #endregion
    }
}
