﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives

using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core.Helpers;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Node.Remove
{
    /// <summary>
    /// Remove-SFNodeSupportBundle is used to delete all support bundles generated with the New-SFSupportBundle CmdLet.
    /// </summary>
    
    [Cmdlet(VerbsCommon.Remove, "SFNodeSupportBundle", SupportsShouldProcess = true, ConfirmImpact=ConfirmImpact.High)]
    public class RemoveSFNodeSupportBundle : SFCmdlet
    {
        #region Private Data

        #endregion

        #region Parameters

        #endregion

        #region Cmdlet Overrides

        /// <summary>
        /// Create a nested pipeline that can be written to after processing
        /// </summary>
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection(minVersionNumber: 8.0f, endPoint: SolidFireUtilities.SFEndPoint.Node);
        }

        /// <summary>
        /// Implementation for processing the execution of the cmdlet.
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();

            SendRequest<DeleteAllSupportBundlesResult>("DeleteAllSupportBundles");
            
        }

        #endregion
    }
}