#region Copyright
/*
* Copyright 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion


#region Using Directives
using System;
using System.Linq;
using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.VirtualVolume
{
	/// <summary>
	/// ListVirtualVolumeBindings returns a list of VVol bindings.
	/// </summary>
	
	[Cmdlet(VerbsCommon.Get, "SFVirtualVolumeBinding")]
	public class ListVirtualVolumeBinding : SFCmdlet
	{
		#region Private Data
		private long[] _virtualVolumeBindingIDs;
		#endregion
		
		#region Parameters
		[Parameter(Mandatory = false)]
		public long[] VirtualVolumeBindingIDs
		{
			get
			{
				return _virtualVolumeBindingIDs;
			}
			set
			{
				_virtualVolumeBindingIDs = value;
			}
		}
		#endregion
		
		#region Cmdlet Overrides
		protected override void BeginProcessing()
		{
			base.BeginProcessing();
			CheckConnection(9);
		}

		protected override void ProcessRecord()
		{
			base.ProcessRecord();
			var request = new ListVirtualVolumeBindingsRequest();
			request.VirtualVolumeBindingIDs = _virtualVolumeBindingIDs;
			var objsFromAPI = SendRequest<ListVirtualVolumeBindingsResult>("ListVirtualVolumeBindings", request);
			WriteObject(objsFromAPI.Select(obj => obj.Result), true);
		}
		#endregion
	}
}
		