#region Copyright
/*
* Copyright 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion


#region Using Directives
using System;
using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core.Validation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.VirtualVolume
{
	/// <summary>
	/// Enables retrieval of the number of virtual volumes currently in the system.
	/// </summary>
	
	[Cmdlet(VerbsCommon.Get, "SFVirtualVolumeCount")]
	public class GetVirtualVolumeCount : SFCmdlet
	{
		#region Private Data
		#endregion
		
		#region Parameters
		#endregion
		
		#region Cmdlet Overrides
		protected override void BeginProcessing()
		{
			base.BeginProcessing();
			CheckConnection(9);
		}

		protected override void ProcessRecord()
		{
			base.ProcessRecord();
			var objsFromAPI = SendRequest<GetVirtualVolumeCountResult>("GetVirtualVolumeCount");
			foreach(var obj in objsFromAPI) {
				WriteObject(obj.Result, true);
			}
		}
		#endregion
	}
}
		