#region Copyright
/*
* Copyright 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion


#region Using Directives
using System;
using System.Linq;
using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.VirtualVolume
{
	/// <summary>
	/// ListVirtualVolumeHosts returns a list of known ESX hosts.
	/// </summary>
	
	[Cmdlet(VerbsCommon.Get, "SFVirtualVolumeHost")]
	public class ListVirtualVolumeHost : SFCmdlet
	{
		#region Private Data
		private Guid[] _virtualVolumeHostIDs;
		#endregion
		
		#region Parameters
		[Parameter(Mandatory = false)]
		public Guid[] VirtualVolumeHostIDs
		{
			get
			{
				return _virtualVolumeHostIDs;
			}
			set
			{
				_virtualVolumeHostIDs = value;
			}
		}
		#endregion
		
		#region Cmdlet Overrides
		protected override void BeginProcessing()
		{
			base.BeginProcessing();
			CheckConnection(9);
		}

		protected override void ProcessRecord()
		{
			base.ProcessRecord();
			var request = new ListVirtualVolumeHostsRequest();
			request.VirtualVolumeHostIDs = _virtualVolumeHostIDs;
			var objsFromAPI = SendRequest<ListVirtualVolumeHostsResult>("ListVirtualVolumeHosts", request);
			WriteObject(objsFromAPI.Select(obj => obj.Result), true);
		}
		#endregion
	}
}
		