#region Copyright
/*
* Copyright 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion


#region Using Directives
using System;
using System.Linq;
using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.VirtualVolume
{
	/// <summary>
	/// ListVirtualVolumeTasks returns a list of VVol Async Tasks.
	/// </summary>
	
	[Cmdlet(VerbsCommon.Get, "SFVirtualVolumeTask")]
	public class GetSFVirtualVolumeTask : SFCmdlet
	{
		#region Private Data
		private Guid[] _virtualVolumeTaskIDs;
		#endregion
		
		#region Parameters
		[Parameter(Mandatory = false)]
		public Guid[] VirtualVolumeTaskIDs
		{
			get
			{
				return _virtualVolumeTaskIDs;
			}
			set
			{
				_virtualVolumeTaskIDs = value;
			}
		}
		#endregion
		
		#region Cmdlet Overrides
		protected override void BeginProcessing()
		{
			base.BeginProcessing();
			CheckConnection(9);
		}

		protected override void ProcessRecord()
		{
			base.ProcessRecord();
			var request = new ListVirtualVolumeTasksRequest();
			request.VirtualVolumeTaskIDs = _virtualVolumeTaskIDs;
			var objsFromAPI = SendRequest<ListVirtualVolumeTasksResult>("ListVirtualVolumeTasks", request);
			WriteObject(objsFromAPI.Select(obj => obj.Result), true);
		}
		#endregion
	}
}
		