﻿#region Copyright
/*
* Copyright © 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion

#region Using Directives
using System;
using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core.Validation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Volume.Remove
{
    /// <summary>
    /// 
    /// 
    /// </summary>
    
    [Cmdlet(VerbsCommon.Remove, "SFVolumeAccessGroup", DefaultParameterSetName = "VolumeAccessGroupId", SupportsShouldProcess = true, ConfirmImpact = ConfirmImpact.High)]
    public class RemoveSFVolumeAccessGroup : SFCmdlet
    {
        #region Private Data

        /// <summary>
        /// 
        /// </summary>
        private Int64[] volumeAccessGroupId;

        #endregion

        #region Parameters

        [Parameter(Position = 0, ParameterSetName = "VolumeAccessGroupId", Mandatory = true, ValueFromPipeline = true, ValueFromPipelineByPropertyName = true, ValueFromRemainingArguments = false, HelpMessage = "volume access group ID(s) to remove")]
        [ValidateNotNullOrEmpty]
        [ValidatePattern(SolidFireValidations.Numeric)]
        public Int64[] VolumeAccessGroupID
        {
            get
            {
                return volumeAccessGroupId;
            }
            set
            {
                volumeAccessGroupId = value;
            }
        }



        #endregion

        #region Cmdlet Overrides
        protected override void BeginProcessing()
        {
            base.BeginProcessing();
            CheckConnection();
        }
        /// <summary>
        /// 
        /// </summary>
        protected override void ProcessRecord()
        {
            base.ProcessRecord();
            foreach (var id in volumeAccessGroupId)
            {
                var request = new DeleteVolumeAccessGroupRequest();
                request.VolumeAccessGroupID = id;
                SendRequest<DeleteVolumeAccessGroupResult>("DeleteVolumeAccessGroup", request);
            }
        }

        #endregion
    }
}