#region Copyright
/*
* Copyright 2014-2016 NetApp, Inc. All Rights Reserved.
*
* CONFIDENTIALITY NOTICE: THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION OF
* NETAPP, INC. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
* EXPRESS WRITTEN PERMISSION OF NETAPP, INC.
*/
#endregion


#region Using Directives
using System;
using System.Linq;
using System.ComponentModel;
using System.Management.Automation;
using SolidFire.Core;
using SolidFire.Element.Api;
#endregion

namespace SolidFire.Volume.Stop
{
	/// <summary>
	/// Cancels a currently running clone operation.
	/// </summary>
	
	[Cmdlet(VerbsLifecycle.Stop, "SFClone")]
	public class StopSFClone : SFCmdlet
	{
		#region Private Data
		private Int64 _cloneID;
		#endregion
		
		#region Parameters
		[Parameter(Mandatory = true, ValueFromPipeline = true, ValueFromPipelineByPropertyName = true, HelpMessage = "The id of the clone you wish to stop. This should have been returned when you first made the object")]
		public Int64 CloneID
		{
			get
			{
				return _cloneID;
			}
			set
			{
				_cloneID = value;
			}
		}
		#endregion
		
		#region Cmdlet Overrides
		protected override void BeginProcessing()
		{
			base.BeginProcessing();
			CheckConnection(9);
		}

		protected override void ProcessRecord()
		{
			base.ProcessRecord();
			var request = new CancelCloneRequest();
			request.CloneID = _cloneID;
			SendRequest<CancelCloneResult>("CancelClone", request);
		}
		#endregion
	}
}
		